import moment from 'moment';
import { useEffect, useState } from 'react';
import { useTranslation } from 'react-i18next';
import { useStore } from '@/shared/model/store';
import { IMAGE_ROOT } from '@/shared/constants/common';
import { PATHS } from '@/shared/constants/paths';
import { useNavigate } from '@/shared/lib/hooks/use-navigate';
import { BillingList } from '@/entities/transaction/ui/billing-list';
import { 
	TransactionCategory, 
	BillingRequestStatus, 
	BillingProcessResult, 
	BillingPaymentMethod, 
	BillingSearchType, 
	ListItemProps, 
	BillingListParams, 
	BillingListResponse 
} from '@/entities/transaction/model/types';
import { useBillingListMutation } from '@/entities/transaction/api/use-billing-list-mutation';
import { useDownloadExcelMutation } from '@/entities/transaction/api/use-download-excel-mutation';
import { DEFAULT_PAGE_PARAM } from '@/entities/common/model/constant';
import { BillingFilter } from '@/entities/transaction/ui/filter/billing-filter';
import { SortTypeBox } from '@/entities/common/ui/sort-type-box';
import { getBillingRequestStatusBtnGroup } from '@/entities/transaction/model/contant';
import { SortTypeKeys, HeaderType, DefaultRequestPagination } from '@/entities/common/model/types';
import { 
	useSetOnBack,
	useSetHeaderTitle,
	useSetHeaderType,
	useSetFooterMode
} from '@/widgets/sub-layout/use-sub-layout';
import { EmailBottomSheet } from '@/entities/common/ui/email-bottom-sheet';
import useIntersectionObserver from '@/widgets/intersection-observer';

export const BillingListPage = () => {
	const { navigate } = useNavigate();
	const { t } = useTranslation();
	const userMid = useStore.getState().UserStore.mid;
	
	const [onActionIntersect, setOnActionIntersect] = useState<boolean>(false);
	const [sortType, setSortType] = useState<SortTypeKeys>(SortTypeKeys.LATEST);
	const [listItems, setListItems] = useState<Array<ListItemProps>>([]);
	const [filterOn, setFilterOn] = useState<boolean>(false);
	const [pageParam, setPageParam] = useState<DefaultRequestPagination>(DEFAULT_PAGE_PARAM);
	const [mid, setMid] = useState<string>(userMid);
	const [searchType, setSearchType] = useState<BillingSearchType>(BillingSearchType.ALL);
	const [searchKeyword, setSearchKeyword] = useState<string>('');
	const [startDate, setStartDate] = useState(moment().subtract(1, 'month').format('YYYYMMDD'));
	//const [startDate, setStartDate] = useState(moment().format('YYYYMMDD'));
	const [endDate, setEndDate] = useState(moment().format('YYYYMMDD'));
	const [requestStatus, setRequestStatus] = useState<BillingRequestStatus>(BillingRequestStatus.ALL);
	const [processResult, setProcessResult] = useState<BillingProcessResult>(BillingProcessResult.ALL);
	const [paymentMethod, setPaymentMethod] = useState<BillingPaymentMethod>(BillingPaymentMethod.ALL);
	const [minAmount, setMinAmount] = useState<number>();
	const [maxAmount, setMaxAmount] = useState<number>();

	const [downloadBottomSheetOn, setDownloadBottomSheetOn] = useState<boolean>(false);

	useSetHeaderTitle(t('billing.title'));
	useSetHeaderType(HeaderType.LeftArrow);
	useSetOnBack(() => {
		navigate(PATHS.home);
	});
  useSetFooterMode(false);

	const { mutateAsync: billingList } = useBillingListMutation();
	const { mutateAsync: downloadExcel } = useDownloadExcelMutation();
	const onIntersect: IntersectionObserverCallback = (entries: Array<IntersectionObserverEntry>) => {
    entries.forEach((entry: IntersectionObserverEntry) => {
      if(entry.isIntersecting){
        if(onActionIntersect && !!pageParam.cursor){
					setOnActionIntersect(false);
          callList('page');
        } 
      }
    });
  };

	const { setTarget } = useIntersectionObserver({ 
    threshold: 1, 
    onIntersect 
  });

	const callList = (type?: string) => {
		setOnActionIntersect(false);
		let listParams: BillingListParams = {
      mid: mid,
      searchType: searchType,
			searchKeyword: searchKeyword,
      startDate: startDate,
      endDate: endDate,
      requestStatus: requestStatus,
      processResult: processResult,
      paymentMethod: paymentMethod,
			minAmount: minAmount,
			maxAmount: maxAmount,
			page: {
				...pageParam,
				...{ sortType: sortType }
			}
    };
		if(type !== 'page' && listParams.page){
      listParams.page.cursor = null;
    }
				    
    billingList(listParams).then((rs: BillingListResponse) => {
      if(type === 'page'){
        setListItems([
          ...listItems,
          ...rs.content
        ]);
      }
      else{
        setListItems(rs.content);
      }
			if(rs.hasNext 
				&& rs.nextCursor !== pageParam.cursor
        && rs.content.length === DEFAULT_PAGE_PARAM.size
      ){
        setPageParam({
          ...pageParam,
          ...{ cursor: rs.nextCursor }
        });
      }
      else{
        setPageParam({
          ...pageParam,
          ...{ cursor: null }
        });
			}
			setOnActionIntersect(
        !!rs.hasNext 
				&& rs.nextCursor !== pageParam.cursor
        && rs.content.length === DEFAULT_PAGE_PARAM.size
      );
    });
	}
	
	const onClickToOpenFilter = () => {
    setFilterOn(!filterOn);
  };
  const onClickToOpenDownloadBottomSheet = () => {
    setDownloadBottomSheetOn(true);
  };
  const onClickToSort = (sort: SortTypeKeys) => {
    setSortType(sort);
  };

	const onClickToRequestStatus = (val: BillingRequestStatus) => {
    setRequestStatus(val);
  };

	const onRequestDownload = (userEmail?: string) => {

	};

  useEffect(() => {
		callList();
	}, [
		mid, searchType, searchKeyword,
		startDate, endDate, sortType,
		requestStatus, processResult, paymentMethod,
		minAmount, maxAmount
	]);
	
	return (
		<>
			<main>
				<div className="tab-content pb-86">
					<div className="tab-pane sub active">
						<div className="summary-section">
							<div className="credit-controls">
								<div>
									<input 
										type="text" 
										className="credit-period" 
										value={ moment(startDate).format('YYYY.MM.DD') + '-' + moment(endDate).format('YYYY.MM.DD') } 
										readOnly={ true } 
									/>
									<button className="filter-btn">
										<img
											src={ IMAGE_ROOT + '/ico_setting.svg' }
											alt={ t('transaction.searchOptions') }
											onClick={ () => onClickToOpenFilter() }
										/>
									</button>
								</div>
								<button className="download-btn">
									<img
										src={ IMAGE_ROOT + '/ico_download.svg' }
										alt={ t('transaction.download') }
										onClick={ () => onClickToOpenDownloadBottomSheet() }
									/>
								</button>
							</div>
						</div>
							
						<div className="filter-section">
							<SortTypeBox
								sortType={ sortType }
								onClickToSort={ onClickToSort }
							></SortTypeBox>
							<div className="excrow">
								<div className="full-menu-keywords no-padding">
								{
									getBillingRequestStatusBtnGroup(t).map((value: any, index: number) => (
										<span
											key={ `key-service-code=${ index }` }
											className={ `keyword-tag ${(requestStatus === value.value)? 'active': ''}` }
											onClick={ () => onClickToRequestStatus(value.value) }
										>{ value.name }</span>
									))
								}
								</div>
							</div>
						</div>
						<BillingList 
							listItems={ listItems }
							transactionCategory={ TransactionCategory.Billing }
						></BillingList>
						<div ref={ setTarget }></div>
					</div>
				</div>
			</main>
			<BillingFilter
        filterOn={ filterOn }
        setFilterOn={ setFilterOn }
				mid={ mid }
				searchType={ searchType }
				searchKeyword={searchKeyword }
				startDate={ startDate }
				endDate={ endDate }
				requestStatus={ requestStatus }
				processResult={ processResult }
				paymentMethod={ paymentMethod }
				minAmount={ minAmount }
				maxAmount={ maxAmount }
				setMid={ setMid }
				setSearchType={ setSearchType }
				setSearchKeyword={ setSearchKeyword }
				setStartDate={ setStartDate }
				setEndDate={ setEndDate }
				setRequestStatus={ setRequestStatus }
				setProcessResult={ setProcessResult }
				setPaymentMethod={ setPaymentMethod }
				setMinAmount={ setMinAmount }
				setMaxAmount={ setMaxAmount }
      ></BillingFilter>
			{ !!downloadBottomSheetOn &&
				<EmailBottomSheet
					bottomSheetOn={ downloadBottomSheetOn }
					setBottomSheetOn={ setDownloadBottomSheetOn }
					imageSave={ false }
					sendEmail={ true }
					sendRequest={ onRequestDownload }
				></EmailBottomSheet>
			}
		</>
	);
};